/*
 * _6502_pc.c
 *
 * Created: 12/1/2013 5:56:44 PM
 *  Author: Vlady
 */ 

#include "c6502_pc.h"
#define F_CPU 18432000UL
#include <avr/io.h>
#include "usart.h"
#include "c6502_cpu.h"
#include <util/delay.h>
#include "ram_mgr.h"
#include "rom_mgr.h"
#include <avr/interrupt.h>
#include "rom.h"
#include "timers.h"
#include "ff.h"	

FATFS FatFs;		/* FatFs work area needed for each volume */
FIL Fil;			/* File object needed for each open file */


uint8_t read6502(uint16_t address)
{
	
	if (address < CACHE_SIZE)
	{
		return cache[address];
	}
	
	
	if (address == 0xf004) 
	{
		unsigned char recei;
		recei = rxc;
		rxc = 0;
		
		
		//
		if (recei == ']')
		{
			uint64_t tmp = (uint64_t) (timer1_mplr << 16 ) + (uint64_t)TCNT1;
			tmp = tmp * 1024;
			tmp = tmp /instructions;
			
			
			
			serial_put_byte2ascii(tmp>>40);
			serial_put_byte2ascii(tmp>>32);
			serial_put_byte2ascii(tmp>>24);
			serial_put_byte2ascii(tmp>>16);
			serial_put_byte2ascii(tmp>>8);
			serial_put_byte2ascii(tmp);
			serial_putc('\n');
			serial_putc('\r');
		}
		//
		
		return recei;
	

	}
	
	
	if (address >= 0xc000)
	{
		//return rom_read((address-0xc000));
		return ram_read(address);
		//return pgm_read_byte(&(rom_data[address-0xc000]));
	};
	
	if (address<0xc000)
	{
		return ram_read(address);
	};
	
	
	
	//return 0xea;
	//serial_putc(address>>8);
	//serial_putc(address);
}
void write6502(uint16_t address, uint8_t value)
{
	
	if (address<CACHE_SIZE)
	{
		cache[address]=value;
		return;
	}
	
	
	if (address == 0xf001) 
	serial_putc(value);
	
	if (address<0xc000)
	{
		ram_write(address, value);
	}
}

int main(void)
{
	
	char_received=0;
	usart_init();
	rom_init();
	ram_init();
	
	//serial_put_byte2ascii(pgm_read_byte(&(rom_data[0xffff-0xc000])));
	
	
	
	//////////////////////////////////////////////////////////////////////////
	
		UINT bw;


		f_mount(&FatFs, "", 0);		/* Give a work area to the default drive */
	
		char arr[1];
		char res = f_open(&Fil, "newfile.txt", FA_READ );
		serial_put_byte2ascii(res);
		if (res == FR_OK)	/* Create a file */
		{
			uint16_t addr=0;
			
do 
{
				f_read(&Fil, arr, 1,  &bw);
				//serial_putc(arr[0]);
				ram_write(0xc000+addr,arr[0]);
				addr++;
				if (addr%512==0)
				{
					serial_put_byte2ascii(addr>>8);
					serial_put_byte2ascii(addr);
					serial_putc('\r');
					serial_putc('\n');
				}
} while (bw==1);


			f_close(&Fil);								/* Close the file */
		}
		
		
	////
	
	
	
	serial_putc('x');
	serial_put_byte2ascii(ram_read(0xfffd));
	serial_put_byte2ascii(ram_read(0xfffc));
	reset6502();
	sei();	
	
	timer1_init();
	timer1_start(PRESCALER_1024);
    
	while(1)
    {
	
			step6502();
			
    }
}