/*
 * rom_mgr.c
 *
 * Created: 12/7/2013 6:38:20 PM
 *  Author: Vlady
 */ 


#include "rom_mgr.h"
#include "sspi.h"

void rom_init(void)
{
	CS_ROM_INIT(); CS_ROM_H();		/* Initialize port pin tied to CS */
	CK_INIT(); CK_L();		/* Initialize port pin tied to SCLK */
	DI_INIT();				/* Initialize port pin tied to DI */
	DO_INIT();				/* Initialize port pin tied to DO */
	

}


void rom_wren(void)
{
		CS_ROM_L();
		xmit(0x06);
		CS_ROM_H();
}
void rom_wrds(void)
{
		CS_ROM_L();
		xmit(0x04);
		CS_ROM_H();	
}

unsigned char rom_read_sr(void)
{
	unsigned char receive;
			CS_ROM_L();
			xmit(0x05);			
			receive= rcvr();
			CS_ROM_H();
			return receive;
}
void rom_write_sr(unsigned char data)
{
			CS_ROM_L();
			xmit(0x01);
			xmit(data);
			CS_ROM_H();
}

unsigned char rom_read(uint16_t addr)
{
	unsigned char receive;
	CS_ROM_L();
	xmit(0x03);
	xmit(addr>>8);
	xmit(addr);
	receive= rcvr();
	CS_ROM_H();
	return receive;
}

void rom_write(uint16_t addr, unsigned char data)
{
	
	CS_ROM_L();
	xmit(0x02);
	xmit(addr>>8);
	xmit(addr);
	xmit(data);
	CS_ROM_H();
}