/*
 * timers.h
 *
 * Created: 12/26/2013 8:16:27 PM
 *  Author: Vlady
 */ 


#ifndef TIMERS_H_
#define TIMERS_H_

#include <avr/io.h>
#include <avr/interrupt.h>

uint32_t timer1_mplr;

#define PRESCALER_1    1
#define PRESCALER_8    2
#define PRESCALER_64   3
#define PRESCALER_256  4
#define PRESCALER_1024 5

#define T1_PRESCALER		PRESCALER_1024  

static inline void timer1_start(unsigned char val)
{
	TCCR1B = val;
	TCNT1 = 0;
}

static inline void timer1_stop(void)
{
	TCCR1B = 0x00;
}

static inline void timer1_set(unsigned int val)
{
	TCNT1 = val;
}


void timer1_init(void)
{
	TIMSK1 |= (1 << TOIE0);
	timer1_mplr=0;
}


ISR(TIMER1_OVF_vect)
{
	timer1_mplr++;
}
#endif /* TIMERS_H_ */