/*
 * usart.c
 *
 * Created: 12/1/2013 6:52:40 PM
 *  Author: Vlady
 */ 

#include "usart.h"
#include <avr/interrupt.h>


ISR (USART_RX_vect)
{
	rxc = UDR0;                       
   // char_received = 1;  
}


void usart_init(void)
{
	UBRR0H = UART_BAUDRATE>>8;
	UBRR0L = UART_BAUDRATE;
	UCSR0B =((1<<RXCIE0)|(1<<RXEN0)|(1<<TXEN0));
	//UCSR0B =((1<<RXEN0)|(1<<TXEN0));
	UCSR0C =((1<<UCSZ01)|(1<<UCSZ00));
}

void serial_putc(unsigned char data)
{
	// wait for USART to become available
	while ( (UCSR0A & _BV(UDRE0)) != _BV(UDRE0));
	UDR0 = data; 									// send character
}; //end usart_putc

void serial_put_byte2ascii(unsigned char val)
{
	unsigned char ascii1=val;
	serial_putc( ((ascii1>>4) < 10) ? (ascii1>>4) + 48 : (ascii1>>4) + 55 );  // upper nibble
	serial_putc( ((val&0x0f) < 10) ? (val&0x0f) + 48 : (val&0x0f) + 55 );  // lower nibble
}